Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.sun.jna.platform.win32
Interface Netapi32

All Superinterfaces:
  com.sun.jna.AltCallingConvention, com.sun.jna.Library, com.sun.jna.win32.StdCall, com.sun.jna.win32.StdCallLibrary

    public interface Netapi32

extends com.sun.jna.win32.StdCallLibrary

Netapi32.dll Interface.

Nested Class Summary

Nested classes/interfaces inherited from interface com.sun.jna.win32.StdCallLibrary
`com.sun.jna.win32.StdCallLibrary.StdCallCallback`

Nested classes/interfaces inherited from interface com.sun.jna.Library
`com.sun.jna.Library.Handler`

Field Summary
`static Netapi32` | `INSTANCE`

Fields inherited from interface com.sun.jna.win32.StdCallLibrary
`FUNCTION_MAPPER, STDCALL_CONVENTION`

Fields inherited from interface com.sun.jna.Library
`OPTION_ALLOW_OBJECTS, OPTION_CALLING_CONVENTION, OPTION_FUNCTION_MAPPER, OPTION_INVOCATION_MAPPER, OPTION_STRUCTURE_ALIGNMENT, OPTION_TYPE_MAPPER`

Method Summary
`int` | `DsEnumerateDomainTrusts(java.lang.String serverName, com.sun.jna.NativeLong Flags, DsGetDC.PDS_DOMAIN_TRUSTS.ByReference Domains, com.sun.jna.ptr.NativeLongByReference DomainCount)` The DsEnumerateDomainTrusts function obtains domain trust data for a specified domain.
`int` | `DsGetDcName(java.lang.String ComputerName, java.lang.String DomainName, Guid.GUID DomainGuid, java.lang.String SiteName, int Flags, DsGetDC.PDOMAIN_CONTROLLER_INFO.ByReference DomainControllerInfo)` The DsGetDcName function returns the name of a domain controller in a specified domain.
`int` | `DsGetForestTrustInformation(java.lang.String serverName, java.lang.String trustedDomainName, int Flags, NTSecApi.PLSA_FOREST_TRUST_INFORMATION.ByReference ForestTrustInfo)` The DsGetForestTrustInformationW function obtains forest trust data for a specified domain.
`int` | `NetApiBufferFree(com.sun.jna.Pointer buffer)` Frees the memory that the NetApiBufferAllocate function allocates.
`int` | `NetGetDCName(java.lang.String serverName, java.lang.String domainName, com.sun.jna.ptr.PointerByReference bufptr)` Returns the name of the primary domain controller (PDC).
`int` | `NetGetJoinInformation(java.lang.String lpServer, com.sun.jna.ptr.PointerByReference lpNameBuffer, com.sun.jna.ptr.IntByReference BufferType)` Retrieves join status information for the specified computer.
`int` | `NetGroupEnum(java.lang.String servername, int level, com.sun.jna.ptr.PointerByReference bufptr, int prefmaxlen, com.sun.jna.ptr.IntByReference entriesread, com.sun.jna.ptr.IntByReference totalentries, com.sun.jna.ptr.IntByReference resume_handle)` The NetGroupEnum function retrieves information about each global group in the security database, which is the security accounts manager (SAM) database or, in the case of domain controllers, the Active Directory.
`int` | `NetLocalGroupEnum(java.lang.String serverName, int level, com.sun.jna.ptr.PointerByReference bufptr, int prefmaxlen, com.sun.jna.ptr.IntByReference entriesread, com.sun.jna.ptr.IntByReference totalentries, com.sun.jna.ptr.IntByReference resume_handle)` Returns information about each local group account on the specified server.
`int` | `NetUserAdd(java.lang.String servername, int level, com.sun.jna.Structure buf, com.sun.jna.ptr.IntByReference parm_err)` The NetUserAdd function adds a user account and assigns a password and privilege level.
`int` | `NetUserChangePassword(java.lang.String domainname, java.lang.String username, java.lang.String oldpassword, java.lang.String newpassword)` The NetUserChangePassword function changes a user's password for a specified network server or domain.
`int` | `NetUserDel(java.lang.String servername, java.lang.String username)` The NetUserDel function deletes a user account from a server.
`int` | `NetUserEnum(java.lang.String servername, int level, int filter, com.sun.jna.ptr.PointerByReference bufptr, int prefmaxlen, com.sun.jna.ptr.IntByReference entriesread, com.sun.jna.ptr.IntByReference totalentries, com.sun.jna.ptr.IntByReference resume_handle)` The NetUserEnum function provides information about all user accounts on a server.
`int` | `NetUserGetGroups(java.lang.String servername, java.lang.String username, int level, com.sun.jna.ptr.PointerByReference bufptr, int prefmaxlen, com.sun.jna.ptr.IntByReference entriesread, com.sun.jna.ptr.IntByReference totalentries)` The NetUserGetGroups function retrieves a list of global groups to which a specified user belongs.
`int` | `NetUserGetLocalGroups(java.lang.String servername, java.lang.String username, int level, int flags, com.sun.jna.ptr.PointerByReference bufptr, int prefmaxlen, com.sun.jna.ptr.IntByReference entriesread, com.sun.jna.ptr.IntByReference totalentries)` The NetUserGetLocalGroups function retrieves a list of local groups to which a specified user belongs.

Field Detail

### INSTANCE

    static final Netapi32 INSTANCE

Method Detail

### NetGetJoinInformation

    int NetGetJoinInformation(java.lang.String lpServer,
                              com.sun.jna.ptr.PointerByReference lpNameBuffer,
                              com.sun.jna.ptr.IntByReference BufferType)

  Retrieves join status information for the specified computer.

  Parameters:
    `lpServer` - Specifies the DNS or NetBIOS name of the computer on which to call the function.
    `lpNameBuffer` - Receives the NetBIOS name of the domain or workgroup to which the computer is joined.
    `BufferType` - Join status of the specified computer.
  Returns:
    If the function succeeds, the return value is NERR_Success. If the function fails, the return value is a system error code.

### NetApiBufferFree

    int NetApiBufferFree(com.sun.jna.Pointer buffer)

  Frees the memory that the NetApiBufferAllocate function allocates.

  Parameters:
    `buffer` -
  Returns:
    If the function succeeds, the return value is NERR_Success. If the function fails, the return value is a system error code.

### NetLocalGroupEnum

    int NetLocalGroupEnum(java.lang.String serverName,
                          int level,
                          com.sun.jna.ptr.PointerByReference bufptr,
                          int prefmaxlen,
                          com.sun.jna.ptr.IntByReference entriesread,
                          com.sun.jna.ptr.IntByReference totalentries,
                          com.sun.jna.ptr.IntByReference resume_handle)

  Returns information about each local group account on the specified server.

  Parameters:
    `serverName` - Specifies the DNS or NetBIOS name of the remote server on which the function is to execute. If this parameter is NULL, the local computer is used.
    `level` - Specifies the information level of the data.
    `bufptr` - Pointer to the address of the buffer that receives the information structure.
    `prefmaxlen` - Specifies the preferred maximum length of returned data, in bytes.
    `entriesread` - Pointer to a value that receives the count of elements actually enumerated.
    `totalentries` - Pointer to a value that receives the approximate total number of entries that could have been enumerated from the current resume position.
    `resume_handle` - Pointer to a value that contains a resume handle that is used to continue an existing local group search.
  Returns:
    If the function succeeds, the return value is NERR_Success.

### NetGetDCName

    int NetGetDCName(java.lang.String serverName,
                     java.lang.String domainName,
                     com.sun.jna.ptr.PointerByReference bufptr)

  Returns the name of the primary domain controller (PDC).

  Parameters:
    `serverName` - Specifies the DNS or NetBIOS name of the remote server on which the function is to execute. If this parameter is NULL, the local computer is used.
    `domainName` - Specifies the name of the domain.
    `bufptr` - Receives a string that specifies the server name of the PDC of the domain.
  Returns:
    If the function succeeds, the return value is NERR_Success.

### NetGroupEnum

    int NetGroupEnum(java.lang.String servername,
                     int level,
                     com.sun.jna.ptr.PointerByReference bufptr,
                     int prefmaxlen,
                     com.sun.jna.ptr.IntByReference entriesread,
                     com.sun.jna.ptr.IntByReference totalentries,
                     com.sun.jna.ptr.IntByReference resume_handle)

  The NetGroupEnum function retrieves information about each global group in the security database, which is the security accounts manager (SAM) database or, in the case of domain controllers, the Active Directory.

  Parameters:
    `servername` - Pointer to a constant string that specifies the DNS or NetBIOS name of the remote server on which the function is to execute. If this parameter is NULL, the local computer is used.
    `level` - Specifies the information level of the data.
    `bufptr` - Pointer to the buffer to receive the global group information structure. The format of this data depends on the value of the level parameter.
    `prefmaxlen` - Specifies the preferred maximum length of the returned data, in bytes. If you specify MAX_PREFERRED_LENGTH, the function allocates the amount of memory required to hold the data. If you specify another value in this parameter, it can restrict the number of bytes that the function returns. If the buffer size is insufficient to hold all entries, the function returns ERROR_MORE_DATA.
    `entriesread` - Pointer to a value that receives the count of elements actually enumerated.
    `totalentries` - Pointer to a value that receives the total number of entries that could have been enumerated from the current resume position. The total number of entries is only a hint.
    `resume_handle` - Pointer to a variable that contains a resume handle that is used to continue the global group enumeration. The handle should be zero on the first call and left unchanged for subsequent calls. If resume_handle is NULL, no resume handle is stored.
  Returns:
    If the function succeeds, the return value is NERR_Success.

### NetUserEnum

    int NetUserEnum(java.lang.String servername,
                    int level,
                    int filter,
                    com.sun.jna.ptr.PointerByReference bufptr,
                    int prefmaxlen,
                    com.sun.jna.ptr.IntByReference entriesread,
                    com.sun.jna.ptr.IntByReference totalentries,
                    com.sun.jna.ptr.IntByReference resume_handle)

  The NetUserEnum function provides information about all user accounts on a server.

  Parameters:
    `servername` - Pointer to a constant string that specifies the DNS or NetBIOS name of the remote server on which the function is to execute. If this parameter is NULL, the local computer is used.
    `level` - Specifies the information level of the data.
    `filter` - Specifies a value that filters the account types for enumeration.
    `bufptr` - Pointer to the buffer that receives the data. The format of this data depends on the value of the level parameter. This buffer is allocated by the system and must be freed using the NetApiBufferFree function. Note that you must free the buffer even if the function fails with ERROR_MORE_DATA.
    `prefmaxlen` - Specifies the preferred maximum length, in 8-bit bytes of returned data. If you specify MAX_PREFERRED_LENGTH, the function allocates the amount of memory required for the data. If you specify another value in this parameter, it can restrict the number of bytes that the function returns. If the buffer size is insufficient to hold all entries, the function returns ERROR_MORE_DATA.
    `entriesread` - Pointer to a value that receives the count of elements actually enumerated.
    `totalentries` - Pointer to a value that receives the total number of entries that could have been enumerated from the current resume position. Note that applications should consider this value only as a hint.
    `resume_handle` - Pointer to a value that contains a resume handle which is used to continue an existing user search. The handle should be zero on the first call and left unchanged for subsequent calls. If resume_handle is NULL, then no resume handle is stored.
  Returns:
    If the function succeeds, the return value is NERR_Success.

### NetUserGetGroups

    int NetUserGetGroups(java.lang.String servername,
                         java.lang.String username,
                         int level,
                         com.sun.jna.ptr.PointerByReference bufptr,
                         int prefmaxlen,
                         com.sun.jna.ptr.IntByReference entriesread,
                         com.sun.jna.ptr.IntByReference totalentries)

  The NetUserGetGroups function retrieves a list of global groups to which a specified user belongs.

  Parameters:
    `servername` - Pointer to a constant string that specifies the DNS or NetBIOS name of the remote server on which the function is to execute. If this parameter is NULL, the local computer is used.
    `username` - Pointer to a constant string that specifies the name of the user to search for in each group account. For more information, see the following Remarks section.
    `level` - Specifies the information level of the data.
    `bufptr` - Pointer to the buffer that receives the data. This buffer is allocated by the system and must be freed using the NetApiBufferFree function. Note that you must free the buffer even if the function fails with ERROR_MORE_DATA.
    `prefmaxlen` - Specifies the preferred maximum length of returned data, in bytes. If you specify MAX_PREFERRED_LENGTH, the function allocates the amount of memory required for the data. If you specify another value in this parameter, it can restrict the number of bytes that the function returns. If the buffer size is insufficient to hold all entries, the function returns ERROR_MORE_DATA.
    `entriesread` - Pointer to a value that receives the count of elements actually retrieved.
    `totalentries` - Pointer to a value that receives the total number of entries that could have been retrieved.
  Returns:
    If the function succeeds, the return value is NERR_Success.

### NetUserGetLocalGroups

    int NetUserGetLocalGroups(java.lang.String servername,
                              java.lang.String username,
                              int level,
                              int flags,
                              com.sun.jna.ptr.PointerByReference bufptr,
                              int prefmaxlen,
                              com.sun.jna.ptr.IntByReference entriesread,
                              com.sun.jna.ptr.IntByReference totalentries)

  The NetUserGetLocalGroups function retrieves a list of local groups to which a specified user belongs.

  Parameters:
    `servername` - Pointer to a constant string that specifies the DNS or NetBIOS name of the remote server on which the function is to execute. If this parameter is NULL, the local computer is used.
    `username` - Pointer to a constant string that specifies the name of the user for which to return local group membership information. If the string is of the form DomainName\UserName the user name is expected to be found on that domain. If the string is of the form UserName, the user name is expected to be found on the server specified by the servername parameter.
    `level` - Specifies the information level of the data.
    `flags` - Specifies a bitmask of flags. Currently, only the value LG_INCLUDE_INDIRECT is defined. If this bit is set, the function also returns the names of the local groups in which the user is indirectly a member (that is, the user has membership in a global group that is itself a member of one or more local groups).
    `bufptr` - Pointer to the buffer that receives the data. The format of this data depends on the value of the level parameter. This buffer is allocated by the system and must be freed using the NetApiBufferFree function. Note that you must free the buffer even if the function fails with ERROR_MORE_DATA.
    `prefmaxlen` - Specifies the preferred maximum length of returned data, in bytes. If you specify MAX_PREFERRED_LENGTH, the function allocates the amount of memory required for the data. If you specify another value in this parameter, it can restrict the number of bytes that the function returns. If the buffer size is insufficient to hold all entries, the function returns ERROR_MORE_DATA. For more information, see Network Management Function Buffers and Network Management Function Buffer Lengths.
    `entriesread` - Pointer to a value that receives the count of elements actually enumerated.
    `totalentries` - Pointer to a value that receives the total number of entries that could have been enumerated.
  Returns:
    If the function succeeds, the return value is NERR_Success.

### NetUserAdd

    int NetUserAdd(java.lang.String servername,
                   int level,
                   com.sun.jna.Structure buf,
                   com.sun.jna.ptr.IntByReference parm_err)

  The NetUserAdd function adds a user account and assigns a password and privilege level.

  Parameters:
    `servername` - Pointer to a constant string that specifies the DNS or NetBIOS name of the remote server on which the function is to execute.
    `level` - Specifies the information level of the data.
    `buf` - Pointer to the buffer that specifies the data. The format of this data depends on the value of the level parameter.
    `parm_err` - Pointer to a value that receives the index of the first member of the user information structure that causes ERROR_INVALID_PARAMETER. If this parameter is NULL, the index is not returned on error.
  Returns:
    If the function succeeds, the return value is NERR_Success.

### NetUserDel

    int NetUserDel(java.lang.String servername,
                   java.lang.String username)

  The NetUserDel function deletes a user account from a server.

  Parameters:
    `servername` - Pointer to a constant string that specifies the DNS or NetBIOS name of the remote server on which the function is to execute. If this parameter is NULL, the local computer is used.
    `username` - Pointer to a constant string that specifies the name of the user account to delete.
  Returns:
    If the function succeeds, the return value is NERR_Success.

### NetUserChangePassword

    int NetUserChangePassword(java.lang.String domainname,
                              java.lang.String username,
                              java.lang.String oldpassword,
                              java.lang.String newpassword)

  The NetUserChangePassword function changes a user's password for a specified network server or domain.

  Parameters:
    `domainname` - Pointer to a constant string that specifies the DNS or NetBIOS name of a remote server or domain on which the function is to execute. If this parameter is NULL, the logon domain of the caller is used.
    `username` - Pointer to a constant string that specifies a user name. The NetUserChangePassword function changes the password for the specified user. If this parameter is NULL, the logon name of the caller is used.
    `oldpassword` - Pointer to a constant string that specifies the user's old password.
    `newpassword` - Pointer to a constant string that specifies the user's new password.
  Returns:
    If the function succeeds, the return value is NERR_Success.

### DsGetDcName

    int DsGetDcName(java.lang.String ComputerName,
                    java.lang.String DomainName,
                    Guid.GUID DomainGuid,
                    java.lang.String SiteName,
                    int Flags,
                    DsGetDC.PDOMAIN_CONTROLLER_INFO.ByReference DomainControllerInfo)

  The DsGetDcName function returns the name of a domain controller in a specified domain. This function accepts additional domain controller selection criteria to indicate preference for a domain controller with particular characteristics.

  Parameters:
    `ComputerName` - Pointer to a null-terminated string that specifies the name of the server to process this function. Typically, this parameter is NULL, which indicates that the local computer is used.
    `DomainName` - Pointer to a null-terminated string that specifies the name of the domain or application partition to query. This name can either be a DNS style name, for example, fabrikam.com, or a flat-style name, for example, Fabrikam. If a DNS style name is specified, the name may be specified with or without a trailing period.
    `DomainGuid` - Pointer to a GUID structure that specifies the GUID of the domain queried. If DomainGuid is not NULL and the domain specified by DomainName or ComputerName cannot be found, DsGetDcName attempts to locate a domain controller in the domain having the GUID specified by DomainGuid.
    `SiteName` - Pointer to a null-terminated string that specifies the name of the site where the returned domain controller should physically exist. If this parameter is NULL, DsGetDcName attempts to return a domain controller in the site closest to the site of the computer specified by ComputerName. This parameter should be NULL, by default.
    `Flags` - Contains a set of flags that provide additional data used to process the request.
    `DomainControllerInfo` - Pointer to a PDOMAIN_CONTROLLER_INFO value that receives a pointer to a DOMAIN_CONTROLLER_INFO structure that contains data about the domain controller selected. This structure is allocated by DsGetDcName. The caller must free the structure using the NetApiBufferFree function when it is no longer required.
  Returns:
    If the function returns domain controller data, the return value is ERROR_SUCCESS. If the function fails, the return code is one of ERROR_* values.

### DsGetForestTrustInformation

    int DsGetForestTrustInformation(java.lang.String serverName,
                                    java.lang.String trustedDomainName,
                                    int Flags,
                                    NTSecApi.PLSA_FOREST_TRUST_INFORMATION.ByReference ForestTrustInfo)

  The DsGetForestTrustInformationW function obtains forest trust data for a specified domain.

  Parameters:
    `serverName` - Contains the name of the domain controller that DsGetForestTrustInformationW is connected to remotely. The caller must be an authenticated user on this server. If this parameter is NULL, the local server is used.
    `trustedDomainName` - Contains the NETBIOS or DNS name of the trusted domain that the forest trust data is to be retrieved for. This domain must have the TRUST_ATTRIBUTE_FOREST_TRANSITIVE trust attribute. If this parameter is NULL, the forest trust data for the domain hosted by ServerName is retrieved.
    `Flags` - Contains a set of flags that modify the behavior of this function. DS_GFTI_UPDATE_TDO: If this flag is set, DsGetForestTrustInformationW will update the forest trust data of the trusted domain identified by the TrustedDomainName parameter.
    `ForestTrustInfo` - Pointer to an LSA_FOREST_TRUST_INFORMATION structure pointer that receives the forest trust data that describes the namespaces claimed by the domain specified by TrustedDomainName. The Time member of all returned records will be zero.
  Returns:
    Returns NO_ERROR if successful or a Win32 error code otherwise.

### DsEnumerateDomainTrusts

    int DsEnumerateDomainTrusts(java.lang.String serverName,
                                com.sun.jna.NativeLong Flags,
                                DsGetDC.PDS_DOMAIN_TRUSTS.ByReference Domains,
                                com.sun.jna.ptr.NativeLongByReference DomainCount)

  The DsEnumerateDomainTrusts function obtains domain trust data for a specified domain.

  Parameters:
    `serverName` - Pointer to a null-terminated string that specifies the name of a computer in the domain to obtain the trust information for. This computer must be running the Windows 2000 or later operating system. If this parameter is NULL, the name of the local computer is used. The caller must be an authenticated user in this domain.
    `Flags` - Contains a set of flags that determines which domain trusts to enumerate.
    `Domains` - Pointer to a PDS_DOMAIN_TRUSTS value that receives an array of DS_DOMAIN_TRUSTS structures. Each structure in this array contains trust data about a domain. The caller must free this memory when it is no longer required by calling NetApiBufferFree.
    `DomainCount` - Pointer to a ULONG value that receives the number of elements returned in the Domains array.
  Returns:
    Returns ERROR_SUCCESS if successful or a Win32 error code otherwise.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD